(function() {
    var AlipayH5Share = {};
    var shareMessage = {
        title: "",
        imgUrl: "",
        desc: "",
        ready: false
    };
    var collectReadyState = {
        title: false,
        imgUrl: false,
        desc: false
    };
    var imgArr;
    var H5ShareCollector = {
        init: function(strict) {
            var t = this;
            t.strict = (typeof strict ==='undefined')?true:(!!strict);
            t.collectTitle();
            t.collectDesc();
            t.collectThumbnail();
        },
        collectTitle: function() {
            var t = this;
            if (collectReadyState.title) {
                return;
            }
            if (document.title && document.title.trim() !== "") {
                shareMessage.title = t.contentTidy(document.title);
                collectReadyState.title = true;
                t.collectReady();
            } else {
                if (document.getElementsByTagName("H1").length > 0 && document.getElementsByTagName("H1")[0].textContent.length > 0) {
                    var tmpH1 = t.nodeStrFliter(document.getElementsByTagName("H1")[0]);
                    if (t.getStrLen(tmpH1) <= 64 && tmpH1.length > 0) {
                        shareMessage.title = tmpH1;
                        collectReadyState.title = true;
                        t.collectReady();
                    }
                }
            }
        },
        collectThumbnail: function() {
            var t = this;
            var metaImgNode = document.querySelector('meta[name="Alipay:imgUrl"]');
            if (metaImgNode && metaImgNode.getAttribute("content") && metaImgNode.getAttribute("content").trim()) {
                collectReadyState.imgUrl = true;
                shareMessage.imgUrl = metaImgNode.getAttribute("content");
                t.collectReady();
            } else {
                collectReadyState.imgUrl = false;
                t.collectReady();
                imgArr = Array.prototype.slice.call(document.images);
                t.findImgUrl(200*50,2000*500);
                if(!t.strict){
                    if(shareMessage.imgUrl == ''){
                        t.findImgUrl(100*25,200*50);
                    }
                    if(shareMessage.imgUrl == ''){
                        t.findImgUrl(10*10,100*25);
                    }
                }
            }
        },
        findImgUrl: function(min,max) {
            var t = H5ShareCollector;
            if (imgArr.length === 0) {
                collectReadyState.imgUrl = true;
                t.collectReady();
                return;
            }
            if (imgArr.length > 0 && !collectReadyState.imgUrl) {
                for (var i = 0; i < imgArr.length; i++) {
                    var curImg = imgArr[i];
                    if (curImg.complete || curImg.natureWidth) {
                        if ((curImg.naturalHeight * curImg.naturalWidth >= min && curImg.naturalHeight * curImg.naturalWidth < max)) {
                            shareMessage.imgUrl = curImg.src;
                            collectReadyState.imgUrl = true;
                            t.collectReady();
                            imgArr = [];
                        }
                    }
                }
            }
        },
        collectDesc: function() {
            if (collectReadyState.desc) {
                return;
            }
            var t = this;
            var metaDescNode = document.querySelector('meta[name="Alipay:desc"]');
            if (metaDescNode && metaDescNode.getAttribute("content") && metaDescNode.getAttribute("content").trim()) {
                collectReadyState.desc = true;
                shareMessage.desc = metaDescNode.getAttribute("content");
                t.collectReady();
            }
            if (!collectReadyState.desc) {
                t.tarvelPtags(50,2000);
            }
            if (!collectReadyState.desc) {
                t.travelDocument(document.body,50,2000);
            }
            if (!collectReadyState.desc) {
                var descNode = document.querySelector('meta[name="description"]');
                if (descNode && descNode.getAttribute("content") && descNode.getAttribute("content").trim()) {
                    shareMessage.desc = t.contentTidy(descNode.getAttribute("content"));
                    collectReadyState.desc = true;
                    t.collectReady();
                }
            }
            if(!t.strict){
                if (!collectReadyState.desc) {
                    t.tarvelPtags(20,50);
                }
                if (!collectReadyState.desc) {
                    t.travelDocument(document.body,20,50);
                }
                if (!collectReadyState.desc) {
                    t.tarvelPtags(1,20);
                }
                if (!collectReadyState.desc) {
                    t.travelDocument(document.body,1,20);
                }
            }
        },
        collectReady: function() {
            if (collectReadyState.title && collectReadyState.imgUrl && collectReadyState.desc) {
                shareMessage.ready = true;
            }
        },
        tarvelPtags:function(min,max){
            var t=this;
            var pArr = Array.prototype.slice.call(document.getElementsByTagName("P"));
            if (pArr.length > 0) {
                for (var i = 0; i < pArr.length; i++) {
                    var c=pArr[i];
                    if(typeof c ==='undefined'){
                        continue;
                    }
                    if (c.id == "Debug") {
                        continue;
                    }
                    if(t.getCurrentStyle(c,'display')=='none' || t.getCurrentStyle(c,'visibility')=='hidden'){
                        continue;
                    }
                    var pConetent=c.textContent;
                    if (t.getStrLen(pConetent) >= min && t.getStrLen(pConetent) < max) {
                        pConetent = t.nodeStrFliter(c, false);
                    }
                    if (t.getStrLen(pConetent) >= min && t.getStrLen(pConetent) < max) {
                        shareMessage.desc = pConetent;
                        collectReadyState.desc = true;
                        t.collectReady();
                    }
                    if(collectReadyState.desc){
                        break;
                    }
                }
            }
        },
        travelDocument: function(el,min,max) {
            var t = this,
                childNodes = el.childNodes;
            if (childNodes && childNodes.length > 0) {
                for (var i = 0; i < childNodes.length; i++) {
                    var c = childNodes[i];
                    if(typeof c ==='undefined'){
                        continue;
                    }
                    switch (c.nodeType) {
                        case 1:

                            if(t.getCurrentStyle(c,'display')!='none' && t.getCurrentStyle(c,'visibility')!='hidden'){
                                if (c.nodeName != "P" && c.nodeName != "SCRIPT" && c.nodeName != "STYLE") {
                                    t.travelDocument(c,min,max);
                                }
                            }
                            break;
                        case 3:
                            var tmp = c.nodeValue;
                                if (t.getStrLen(tmp) >= min && t.getStrLen(tmp) < max) {
                                    tmp = t.contentTidy(tmp);
                                }
                                if (t.getStrLen(tmp) >= min && t.getStrLen(tmp) <= max) {
                                    shareMessage.desc = tmp;
                                    collectReadyState.desc = true;
                                    t.collectReady();
                                }
                            break;
                    }
                    if (collectReadyState.desc) {
                        break;
                    }
                }
            }
        },
        getStrLen: function(str) {
            return str.replace(/[^\x00-\xff]/g, "xx").length;
        },
        getCurrentStyle:function(obj, prop) {
            if (window.getComputedStyle) {
                return window.getComputedStyle(obj,null).getPropertyValue(prop);
            }else if (obj.currentStyle) {
                return obj.currentStyle[prop];
            }
            return null;
        },
        nodeStrFliter: function(element, imgAlt) {
            imgAlt = imgAlt || true;
            var t = this,
                tmp = element.cloneNode(true);
            if (imgAlt) {
                Array.prototype.forEach.call(tmp.querySelectorAll("img[alt]"), function(el) {
                    el.parentNode.replaceChild(document.createTextNode(el.alt), el);
                });
            }
            Array.prototype.forEach.call(tmp.querySelectorAll("script,style,link"), function(el) {
                el.parentNode.replaceChild(document.createTextNode(""), el);
            });
            tmp = t.contentTidy(tmp.textContent);
            return tmp;
        },
        contentTidy: function(str) {
            return str.replace(/\s{4}/g, " ").replace(/(\r|\n)/g, "").trim();
        }
    };
    if (/complete|loaded|interactive/.test(document.readyState)) {
        H5ShareCollector.init();
    } else {
        document.addEventListener("DOMContentLoaded", function(e) {
            H5ShareCollector.init();
        }, true);
    }
    AlipayH5Share.getShareContent = function(strict) {
        strict = (typeof strict ==='undefined')?true:(!!strict);
        H5ShareCollector.init(strict);
        return JSON.stringify(shareMessage);
    };
    document.addEventListener("JSPlugin_AlipayH5Share", function(e) {
        var strict = (typeof e.strict ==='undefined')?true:(!!e.strict);
        if (AlipayJSBridge && e.clientId) {
            H5ShareCollector.init(strict);
            AlipayJSBridge.callback(e.clientId, shareMessage);
        }
    });
    window.AlipayH5Share = AlipayH5Share;
})();
